<?php

namespace Drupal\simple_autologout\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\DependencyInjection\ContainerInjectionInterface;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Drupal\Component\Utility\Crypt;

/**
 * Returns responses for autologout module routes.
 */
class SimpleAutologoutController extends ControllerBase {

  /**
   * Get the last active time for specific user.
   */
  public function getUserLastActiveTime() {
    $account = \Drupal::currentUser();    
    $user_session = \Drupal::service('session')->getId();
    $session_id = Crypt::hashBase64($user_session);

    $database = \Drupal::database();
    $timestamp = $database->select('sessions', 's')
      ->fields('s', ['timestamp'])
      ->condition('s.uid', $account->id(), '=')
      ->condition('s.sid', $session_id, '=')
      ->execute()
      ->fetchCol();

    $last_active_time = ($timestamp[0] * 1000);
    
    return new JsonResponse([
      'last_active_time' => $last_active_time,
    ]);
  }

  public function logOut() {
    user_logout();
    return new JsonResponse([
      'logout' => 'true',
    ]);
  }
}
